import java.io.PrintStream;
import java.util.Date;

import type.lib.CreditCard;
import type.lib.RewardCard;

/**
 * @author mb
 * 
 */
public class L07App06 {

	public static void main(String[] args) {

		PrintStream output = System.out;
		CreditCard cc, rc;

		cc = new CreditCard(112233, "Charles Oakley", 5000);
		// rc = new CreditCard(112234, "Tim Duncan", 6000);
		rc = new RewardCard(112234, "Tim Duncan", 6000);

		cc.charge(1000);
		rc.charge(1000);

		output.println(cc.toString());
		output.println(rc.toString());

		if (rc instanceof RewardCard) {
			((RewardCard) rc).redeem(10);
		}

		/*
		 * take home point: rc can be declared as a CreditCard at compile time,
		 * but still be assigned a reference to a RewardCard object at run time.
		 * The compiler does not and will not predict the actual type of the
		 * object at run-time.
		 * 
		 * If we plan to do a manual cast, it should be protected with a test to
		 * ensure that we do not inadvertently cause a ClassCastException (e.g.,
		 * instantiate rc as a CreditCard instead of a RewardCard to see this
		 * happen)
		 */
	}
}
